
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the I8123CPS_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// I8123CPS_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef I8123CPS_EXPORTS
#define I8123CPS_API __declspec(dllexport)
#else
#define I8123CPS_API __declspec(dllimport)
#endif


#define		CANopen_Init_Addr		6900
#define		CANopenIO_Init_Addr		6902
#define		Init_Dll_Access_Flag	6980
#define		Init_Fm_Access_Flag		6981
#define		DI_Dll_Access_Flag		6982
#define		DI_Fm_Access_Flag		6983
#define		AI_Dll_Access_Flag		6984
#define		AI_Fm_Access_Flag		6985
#define		DO_Dll_Access_Flag		6986
#define		DO_Fm_Access_Flag		6987
#define		AO_Dll_Access_Flag		6988
#define		AO_Fm_Access_Flag		6989
#define		SEND_EnableWDT_Intt		0xdd
#define		SEND_DisableWDT_Intt 	0xde
#define		SEND_RefreshWDT_Intt	0xdf
#define		DI_Start_Addr			0
#define		AI_Start_Addr			256
#define		DO_Start_Addr			767
#define		AO_Start_Addr			1023


// This class is exported from the I8123CPS.dll
class I8123CPS_API CI8123CPS {
public:
	CI8123CPS(void);
	// TODO: add your methods here.
};

extern I8123CPS_API int nI8123CPS;

I8123CPS_API int fnI8123CPS(void);
I8123CPS_API int I8123CPS_CANopenInit(unsigned char SlotNo, unsigned char BaudRate);
I8123CPS_API int I8123CPS_IOInit(unsigned char SlotNum, unsigned char NodeNo, unsigned short DI_Ch, unsigned short AI_Ch,unsigned short DO_Ch,unsigned short AO_Ch, unsigned short SYNCTime);

I8123CPS_API void I8123CPS_EnalbeWDT(unsigned char SlotNum);
I8123CPS_API void I8123CPS_DisableWDT(unsigned char SlotNum);
I8123CPS_API void I8123CPS_RefreshWDT(unsigned char SlotNum);

I8123CPS_API int I8123CPS_WriteDI(unsigned char SlotNum, unsigned char* DI_Data, unsigned short DataNum);
I8123CPS_API int I8123CPS_WriteAI(unsigned char SlotNum, unsigned char* AI_Data, unsigned short DataNum);
I8123CPS_API int I8123CPS_ReadDO(unsigned char SlotNum,unsigned short DO_address,unsigned char* DO_Data, unsigned short DataNum);
I8123CPS_API int I8123CPS_ReadAO(unsigned char SlotNum,unsigned short AO_address,unsigned char* AO_Data, unsigned short DataNum);
I8123CPS_API int I8123CPS_ReadAllDOAO(unsigned char SlotNum, unsigned char* DO_Data,unsigned short DODataNum, unsigned char* AO_Data,unsigned short AODataNum);
I8123CPS_API int I8123CPS_CheckDOAOCmd( unsigned char SlotNo, unsigned short* Address,  unsigned char* DataNum);
I8123CPS_API int I8123CPS_InstallUserISR( unsigned char SlotNo, void (CALLBACK *UserISR)(void));